<template>
  <div class="ele-body">
    <el-card shadow="never">
      <!-- 搜索表单 -->
      <user-search :typeList="typeOptions" @search="reload" />
      <!-- 数据表格 -->
      <ele-pro-table
        ref="table"
        :columns="columns"
        :datasource="datasource"
        :selection.sync="selection"
        row-key="id"
      >
        <!-- 表头工具栏 -->
        <template v-slot:toolbar>
          <el-button
            size="small"
            type="primary"
            icon="el-icon-plus"
            class="ele-btn-icon"
            @click="openEdit()"
          >
            新建
          </el-button>
          <el-button
            size="small"
            type="danger"
            icon="el-icon-delete"
            class="ele-btn-icon"
            @click="removeBatch"
            plain
          >
            删除
          </el-button>
          <el-button
            size="small"
            type="primary"
            icon="el-icon-upload2"
            class="ele-btn-icon"
            plain
          >
            导出
          </el-button>
          <el-button
            size="small"
            type="primary"
            icon="el-icon-download"
            class="ele-btn-icon"
            plain
          >
            导入
          </el-button>
        </template>

        <!-- 操作列 -->
        <template v-slot:action="{ row }">
          <el-link
            type="primary"
            :underline="false"
            icon="el-icon-edit"
            @click="openEdit(row)"
          >
            修改
          </el-link>
          <el-link
            type="primary"
            :underline="false"
            icon="el-icon-setting"
            @click="openEdit(row, true)"
          >
            详情
          </el-link>

          <el-popconfirm
            class="ele-action"
            title="确定要删除当前工步吗？"
            @confirm="remove(row)"
          >
            <template v-slot:reference>
              <el-link type="danger" :underline="false" icon="el-icon-delete">
                删除
              </el-link>
            </template>
          </el-popconfirm>
        </template>
      </ele-pro-table>
    </el-card>
    <!-- 编辑弹窗 -->
    <user-edit
      :visible.sync="showEdit"
      :data="current"
      :controlList="controlList"
      :isView="isView"
      @done="reload"
      ref="userEdit"
      :typeList="typeOptions"
    />
  </div>
</template>

<script>
  import UserSearch from './components/user-search.vue';
  import UserEdit from './components/user-edit.vue';
  import {
    getProfessionPageList,
    deleteProfessiongetById
  } from '@/api/factoryModel';
  import control from '@/api/technology/control';
  import dictMixins from '@/mixins/dictMixins';

  export default {
    name: 'technologyProduction',
    components: {
      UserSearch,
      UserEdit
    },
    mixins: [dictMixins],
    data() {
      return {
        levelOptions: [
          {
            label: '初级',
            value: '1'
          },
          {
            label: '中级',
            value: '2'
          },
          {
            label: '高级',
            value: '3'
          }
        ],
        isView: false,
        // 表格列配置
        columns: [
          {
            columnKey: 'selection',
            type: 'selection',
            width: 45,
            align: 'center',
            fixed: 'left'
          },
          {
            label: '序号',
            type: 'index',
            width: 55,
            align: 'center'
          },
          {
            slot: 'type',
            label: '类型',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110,
            formatter: (_row) => {
              return this.getDictValue('工种类型', _row.type);
            }
          },
          {
            align: 'center',
            prop: 'code',
            label: '编码',
            showOverflowTooltip: true,
            minWidth: 110
          },
          {
            slot: 'name',
            prop: 'name',
            label: '名称',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110
          },
          {
            slot: 'level',
            prop: 'level',
            label: '等级',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110,
            formatter: (_row) => {
              return this.levelOptions.filter(
                (item) => _row.level == item.value
              )[0].label;
            }
          },
          {
            slot: 'hourCost',
            prop: 'hourCost',
            label: '标准工时费',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110
          },
          // {
          //   slot: 'aptitude',
          //   label: '资质',
          //   showOverflowTooltip: true,
          //   align: 'center',
          //   minWidth: 110,
          //   formatter: (_row) => {
          //     return this.getDictValue('工种类型', _row.aptitude);
          //   }
          // },
          {
            columnKey: 'action',
            label: '操作',
            width: 260,
            align: 'center',
            resizable: false,
            slot: 'action',
            showOverflowTooltip: true
          }
        ],
        // 表格选中数据
        selection: [],
        // 当前编辑数据
        current: null,
        // 是否显示编辑弹窗
        showEdit: false,
        // 是否显示参数弹窗
        showSetting: false,
        controlList: [],
        sampleShow: false,
        taskId: null
      };
    },
    created() {
      this.requestDict('工种类型');
    },
    computed: {
      typeOptions() {
        return this.dict[this.dictEnum['工种类型']];
      }
    },
    methods: {
      /*配置工艺参数 */
      openSetting(row) {
        this.current = row;
        this.showSetting = true;
      },
      /* 表格数据源 */
      async datasource({ page, limit, where, order }) {
        const res = await getProfessionPageList({
          ...where,
          ...order,
          pageNum: page,
          size: limit
        });
        return res;
      },

      /* 刷新表格 */
      reload(where) {
        this.$refs.table.reload({ page: 1, where: where });
      },
      /* 打开编辑弹窗 */
      openEdit(row, isView) {
        this.isView = !!isView;
        this.getControlList();
        this.current = row;
        this.showEdit = true;
        this.$refs.userEdit.$refs.form &&
          this.$refs.userEdit.$refs.form.clearValidate();
      },

      getControlList() {
        const params = {
          pageNum: 1,
          size: -1
        };
        control.list().then((res) => {
          this.controlList = res.list;
        });
      },

      /* 删除 */
      remove(row) {
        const loading = this.$loading({ lock: true });

        deleteProfessiongetById([row.id])
          .then((msg) => {
            loading.close();
            this.$message.success('删除' + msg);
            this.reload();
          })
          .catch((e) => {
            loading.close();
            // this.$message.error(e.message);
          });
      },
      /* 批量删除 */
      removeBatch() {
        if (!this.selection.length) {
          this.$message.error('请至少选择一条数据');
          return;
        }
        this.$confirm('确定要删除选中的工种吗?', '提示', {
          type: 'warning'
        })
          .then(() => {
            const loading = this.$loading({ lock: true });
            deleteProfessiongetById(this.selection.map((d) => d.id))
              .then((msg) => {
                loading.close();
                this.$message.success('删除' + msg);
                this.reload();
              })
              .catch((e) => {
                loading.close();
                // this.$message.error(e.message);
              });
          })
          .catch(() => {});
      },

      sampleParam(row) {
        this.taskId = row.id;
        this.sampleShow = true;
      },

      close(done) {
        this.sampleShow = false;
      }
    }
  };
</script>
